#! /bin/awk -f

#####
#
# jsCopy00.awk
# MDJ 2022/03/26
#
# JavaScript Version Step Three:
#   Copy the file identified
a   on the command line to
#   wk00/dataout; while also
#   adding the Question Number
#   Comment line.
#
# To Run:
#   cdCoCo
#   cd wk00
#   pyCopy00.awk filename
#
#####

BEGIN {
	BNn = 0   # Block Number Counter
	BN = "00" # Block Number Counter Display
	print " "
	print "Beginning of Step Three Copy"
	print " "
}

{

	# First Block
	# First Line of Block
	#  = Question Number Comment Line

	# Truncate $NF to remove trailing "\n"
	NFT = substr($NF,1,2)
	
	# Convert NFT string to numeric
	NFn = 0 + NFT
	
	# Add closing semicolon to string
	NFT = NFT ";"
	$NF = NFT
	
	# Convert BNn Counter to string
	if ( BNn < 10 )
	{
		BN = "0" BNn "\;"
	}
	else
	{
		BN = "" BNn "\;"
	}
	
	if ( NFn == BNn )
	{
		print "Match " BN " " NFT
		print $0
		print $0 > "../wk00/dataout"
	}
	else
	{
		print "No Match " BN " " NFT " ERROR!"
		print $0
		exit 1
	}
	
	# Question Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Correct Answer Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Incorrect Answer #1 Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Incorrect Answer #2 Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Incorrect Answer #3 Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Incorrect Answer #4 Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Blank Line
	getline
	print $0
	print $0 >> "../wk00/dataout"
	
	# Blocks 2 through last:
	# Question Number Comment Line
	while ( 1 == 1 )
	{
		r = getline
		# If EOF:
		if (r <= 0)
		{
			exit 0
		}
		else
		{
			BNn = BNn + 1
	
			# Truncate $NF to remove trailing "\n"
			NFT = substr($NF,1,2)
	
			# Convert NFT string to numeric
			NFn = 0 + NFT
	
			# Add closing semicolon to string
			NFT = NFT ";"
			$NF = NFT
	
			# Convert BNn Counter to string
			if ( BNn < 10 )
			{
				BN = "0" BNn "\;"
			}
			else
			{
				BN = "" BNn "\;"
			}
		
			if ( NFn == BNn )
			{
				print "Match " BN " " NFT
				print $0
				print $0 >> "../wk00/dataout"
			}
			else
			{
				print "No Match " BN " " NFT " ERROR!"
				print $0
				exit 1
			}
		}
		
		# Question Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Correct Answer Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Incorrect Answer #1 Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Incorrect Answer #2 Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Incorrect Answer #3 Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Incorrect Answer #4 Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
		
		# Blank Line
		getline
		print $0
		print $0 >> "../wk00/dataout"
	}
}

END { 
	print "End of Step Three Copy" 
	print " "
}

#####
#
# EOF
#
#####
